// Windows
//

#include <stdio.h>
#include <stdlib.h>
#include "lib/video/gfxlcd.h"
#include "lib/video/lcd.h"
#include "lib/video/lcd_win.h"



/**
 * Swap two integers a and b.
 */
static inline void swap(int &a, int &b)
{
  int t=a;
  a=b; b=t;
}


void DrawWindow(int x1, int y1,int x2,int y2)
{
/*
EMPTY_FILL
SOLID_FILL
LINE_FILL
LTSLASH_FILL
SLASH_FILL
BKSLASH_FILL
LTBKSLASH_FILL
HATCH_FILL
XHATCH_FILL
INTERLEAVE_FILL
WIDE_DOT_FILL
CLOSE_DOT_FILL
USER_FILL
*/
  setfillstyle(SOLID_FILL, 1);
  bar(x1+2,y1+2,x2+2,y2+2);
  setfillstyle(SOLID_FILL, 0);
  bar(x1,y1,x2,y2);
  rectangle(x1,y1,x2,y2);
}

void ShowMessage(char *s)
{
  int height= textheight();
  int width = textwidth(s);
  int x1=(LCD_WIDTH/2)-(width/2)-5;
  int y1=(LCD_HEIGHT/2)-(height/2)-5;
  int x2=(LCD_WIDTH/2)+(width/2)+5;
  int y2=(LCD_HEIGHT/2)+(height/2)+5;

  DrawWindow(x1,y1,x2,y2);
  outtextxy(x1+5,y1+5,s);
}

void DrawVolumeBox(int Vol_Percent)
{
   char info[40];
   sprintf( info, "Volume: %i%", Vol_Percent);

#define VolBoxWidth 65
#define VolBoxHeight 21
   int VolShapeX1=((LCD_WIDTH-VolBoxWidth)/2)+3;
   int VolShapeY1=((LCD_HEIGHT-VolBoxHeight)/2)+13;

   int VolShapeX2=((LCD_WIDTH+VolBoxWidth)/2)-3;
   int VolShapeY2=((LCD_HEIGHT-VolBoxHeight)/2)+3;

   DrawWindow((LCD_WIDTH-VolBoxWidth)/2,(LCD_HEIGHT-VolBoxHeight)/2,
               (LCD_WIDTH+VolBoxWidth)/2,(LCD_HEIGHT+VolBoxHeight)/2);

   //drawtriangle(VolShapeX1,VolShapeY1,VolShapeX2,VolShapeY2);
   //drawtriangle(VolShapeX1,VolShapeY1,);
   //Volume Dreieck zeichnen
   line(VolShapeX1,VolShapeY1,VolShapeX2,VolShapeY1); //waagerecht
   line(VolShapeX2,VolShapeY1,VolShapeX2,VolShapeY2); //senkrecht
   line(VolShapeX1,VolShapeY1,VolShapeX2,VolShapeY2); //diagonal

   //geflltes Dreieck zeichnen
   int dreieck_max_x = (Vol_Percent*(VolShapeX2-VolShapeX1))/100;
   int dreieck_max_y = dreieck_max_x / ((VolShapeX2-VolShapeX1)/(VolShapeY1-VolShapeY2));
   for(int i=0; i<dreieck_max_y; i++)
   {
      line(VolShapeX1+dreieck_max_x,VolShapeY1-i,
           VolShapeX1+dreieck_max_x-((dreieck_max_y-i)*((VolShapeX2-VolShapeX1)/(VolShapeY1-VolShapeY2))),VolShapeY1-i);
   }
   //line(VolShapeX1+dreieck_max_x,VolShapeY1,VolShapeX1+dreieck_max_x,VolShapeY1-dreieck_max_y);

   //Unterschrift
   outtextxy( VolShapeX1, VolShapeY1+2, info);
}

void DrawDimmerBox(int Vol_Percent)
{
   char info[40];
   sprintf( info, "Dimmer: %i%", Vol_Percent);

#define VolBoxWidth 65
#define VolBoxHeight 21
   int ShapeX1=((LCD_WIDTH-VolBoxWidth)/2)+3;
   int ShapeY1=((LCD_HEIGHT-VolBoxHeight)/2)+3;

   int ShapeX2=((LCD_WIDTH+VolBoxWidth)/2)-3;
   int ShapeY2=((LCD_HEIGHT-VolBoxHeight)/2)+10;

   DrawWindow((LCD_WIDTH-VolBoxWidth)/2,(LCD_HEIGHT-VolBoxHeight)/2,
               (LCD_WIDTH+VolBoxWidth)/2,(LCD_HEIGHT+VolBoxHeight)/2);

   //Rahmen fr Bar zeichnen
	rectangle(ShapeX1,ShapeY1,ShapeX2,ShapeY2);

   //Balken zeichnen
   setfillstyle(SOLID_FILL, 1);
	bar(ShapeX1,ShapeY1,ShapeX1+((ShapeX2-ShapeX1)*Vol_Percent/100),ShapeY2);

   //Unterschrift
   outtextxy( ShapeX1, ShapeY2+2, info);
}


void ShowJumpToWindow(int song)
{
#define JumpToBoxWidth 55
#define JumpToBoxHeight 20
   static char buf[1024];
   int X1=((LCD_WIDTH-JumpToBoxWidth)/2);
   int Y1=((LCD_HEIGHT-JumpToBoxHeight)/2);

	DrawWindow(X1,Y1,X1+JumpToBoxWidth,Y1+JumpToBoxHeight);
	setfillstyle(SOLID_FILL, 1);
  	bar(X1+1,Y1+1,X1+JumpToBoxWidth-1,Y1+9);
   outtextxy(X1+3, Y1+3, "Jump to:");

   sprintf(buf, "%i",song);
   outtextxy(X1+3, Y1+12, buf);
}

void drawtriangle(int x1, int y1, int x2, int y2)
{
   int dx = abs(x2-x1);
   int dy = abs(y2-y1);


   // bresenham line
   int c1, c2, p, step;

   if (dx >= dy)
   {
      // step through x axis
      if (x1 > x2)
      {
         swap(x1, x2);
         swap(y1, y2);
      }

      c1 = dy << 1;
      c2 = (dy-dx) << 1;
      p  = (dy<<1) - dx;
      step = (y1 > y2) ? -1 : 1;

      putpixel(x1, y1, 1);
      while (x1 < x2)
      {
        if (p<0)
          p += c1;
        else
        {
          y1 += step;
          p  += c2;
        }
        putpixel(++x1, y1, 1);
      }

   }
   else
   {
   // step through y axis
   if (y1 > y2) {
     swap(x1, x2);
     swap(y1, y2);
   }
   c1 = dx << 1;
   c2 = (dx-dy) << 1;
   p  = (dx<<1) - dy;
   step = (x1>x2) ? -1 : 1;

   putpixel(x1, y1, 1);
   while (y1 < y2) {
     if (p<0)
       p += c1;
     else {
       x1 += step;
       p  += c2;
     }
     putpixel(x1, ++y1, 1);
   }
   }

}

